(* This file brings together all of the lemmas from other files to
   prove our main results. *)

Require Import init_modules.
Require Import inverted_lazy_to_strong.
Require Import inverted_weak_to_weak.
Require Import separation.
Require Import strong_lazy_to_inverted_lazy.
Require Import strong_to_inverted_weak.
Require Import weak_to_strong_lazy.

Theorem strong_to_weak : forall P0 H1 P tr,
  Typ.typing_prgm (HeapTyping.empty_heap_typing _) P0 ->
  StrongSys.system_step_many Strong.empty_heap P0 H1 P tr ->
  exists H2, exists tr',
    WeakSys.system_step_many Weak.empty_heap P0 H2 P tr'.
Proof with eauto.
  intros.
  forwards [ ? [ ? ? ] ] : strong_to_inverted_weak...
  forwards [ ? ? ] : inverted_weak_to_weak...
Qed.

Theorem weak_to_strong : forall P0 H2 P tr,
  Typ.typing_prgm (HeapTyping.empty_heap_typing _) P0 ->
  separation P0 ->
  WeakSys.system_step_many Weak.empty_heap P0 H2 P tr ->
  exists H1, exists P', exists tr',
    StrongSys.system_step_many Strong.empty_heap P0 H1 P' tr'
    /\ L.eq_program_state P P'.
Proof with eauto.
  intros.
  forwards [ ? [ ? [ ? [ ? ? ] ] ] ] : weak_to_strong_lazy...
  forwards [ ? [ ? ? ] ] : strong_lazy_to_inverted_lazy...
  forwards [ ? [ ? [ ? ? ] ] ] : inverted_lazy_to_strong...
Qed.
