Require Import Arith.
Require Import Omega.

Set Implicit Arguments.

(* Just some lemmas about nats so I don't have to use omega all over my proofs.
   It's a slow tactic. *)

Lemma plus_1 : forall n, n + 1 = S n.
Proof.
  intros n. unfold plus. induction n; [ | rewrite IHn ]; auto.
Qed.

Lemma lt_minus_compat_r : forall m n p,
  p <= m ->
  p <= n ->
  m < n ->
  m - p < n - p.
Proof.
  intros. omega.
Qed.

Lemma minus_lt_compat_r : forall m n p,
  m - p < n - p ->
  m < n.
Proof.
  intros. omega.
Qed.

Lemma lt_O_lt_minus : forall m n,
  m < n ->
  0 < n - m.
Proof.
  intros. omega.
Qed.

Lemma S_eq_plus_S : forall m n p,
  S m = n + S p <-> m = n + p.
Proof.
  intros. split; intro; omega.
Qed.

Lemma lt_or_plus_dec : forall m n,
  m < n \/ exists p, m = p + n.
Proof.
  intros m n.
  destruct (le_lt_dec n m).
  right. exists (m - n). omega.
  auto.
Qed.

Lemma plus_reg_r : forall n m p,
  n + p = m + p ->
  n = m.
Proof.
  intros. omega.
Qed.

Lemma plus_le_reg_r : forall n m p,
  n + p <= m + p ->
  n <= m.
Proof.
  intros. omega.
Qed.

Lemma plus_lt_reg_r : forall n m p,
  n + p < m + p ->
  n < m.
Proof.
  intros. omega.
Qed.

Lemma lt_exists_plus : forall n m,
  n < m -> exists p, m = n + p.
Proof.
  intros. exists (m - n). omega.
Qed.

Lemma weaken_le : forall m n,
  m = n -> m <= n.
Proof.
  intros. subst. auto.
Qed.
