Require Import init_modules.

Set Implicit Arguments.

(* Lemma ok_pure_lazy_weak : forall c t, *)
(*   Heap.ok_pure c t -> *)
(*   Heap.ok_pure c t. *)
(* Proof. *)
(*   intros c t OK. *)
(*   inversion OK. *)
(*   apply Weak.ok_pure_inactive. *)
(*   apply Weak.ok_pure_active. *)
(* Qed. *)

Lemma strong_active_implies_weak_active : forall ts t,
  Heap.strong_active ts t ->
  Heap.weak_active ts t.
Proof.
  intros ts t StrongActive.
  inversion StrongActive; subst.
  apply Heap.weak_active_none.
  apply Heap.weak_active_running.
Qed.

Hint Constructors Weak.step Heap.weak_unprotected.
Hint Resolve strong_active_implies_weak_active.
Hint Unfold Weak.heap_step.

Lemma strong_lazy_to_weak_step : forall H1 e H2,
  Lazy.heap_step H1 e H2 ->
  Weak.heap_step H1 e H2.
Proof with eauto.
  intros H1 e H2 LazyStep.
  inversion LazyStep; subst...
Qed.

Lemma strong_lazy_to_weak : forall H1 P1 H2 P2 tr,
  LazySys.system_step_many H1 P1 H2 P2 tr ->
  WeakSys.system_step_many H1 P1 H2 P2 tr.
Proof with eauto.
  intros H1 P1 H2 P2 tr LazySysStepMany.
  induction LazySysStepMany as [ | ? ? ? ? ? ? ? ? ? ? LazyStep ]; subst.
  apply WeakSys.system_step_many_refl.
  eapply WeakSys.system_step_many_trans...
  inversion LazyStep; subst.
  apply WeakSys.system_step_mutual...
  apply strong_lazy_to_weak_step...
  apply WeakSys.system_step_heap.
  apply strong_lazy_to_weak_step...
Qed.
